org.codehaus.groovy.antlr.treewalker

## Class TraversalHelper

- java.lang.Object
- - org.codehaus.groovy.antlr.treewalker.TraversalHelper

All Implemented Interfaces:
  AntlrASTProcessor

Direct Known Subclasses:
  FlatNodeListTraversal, PreOrderTraversal, SourceCodeTraversal

    public abstract class TraversalHelper
    extends java.lang.Object
    implements AntlrASTProcessor

Helper Class for Antlr AST traversal and visitation.

Author:
  Jeremy Rayner

### Field Summary

Fields
`protected java.util.List<GroovySourceAST>` `unvisitedNodes`

### Constructor Summary

Constructors
Constructor and Description
`TraversalHelper(Visitor visitor)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected void` `accept_FirstChild_v_RestOfTheChildren_v_LastChild(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_RestOfTheChildren_v(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_RestOfTheChildren(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_SecondChild_v_ThirdChild_v(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_SecondChild_v(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_SecondChild(GroovySourceAST t)`
`protected void` `accept_FirstChild_v_SecondChildsChildren_v(GroovySourceAST t)`
`protected void` `accept_FirstSecondAndThirdChild_v_v_ForthChild(GroovySourceAST t)`
`protected void` `accept_SecondChild_v_ThirdChild_v(GroovySourceAST t)`
`protected void` `accept_v_AllChildren_v_Siblings(GroovySourceAST t)`
`protected void` `accept_v_AllChildren_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_2ndv_SecondChild_v___LastChild_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_SecondChild_v_ThirdChild_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_v_RestOfTheChildren_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_v_RestOfTheChildren(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_v_SecondChild_v___LastChild_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChild_v(GroovySourceAST t)`
`protected void` `accept_v_FirstChildsFirstChild_v_Child2_Child3_v_Child4_v___v_LastChild(GroovySourceAST t)`
`protected void` `accept_v_FirstChildsFirstChild_v_RestOfTheChildren(GroovySourceAST t)`
`protected void` `accept_v_Siblings_v(GroovySourceAST t)`
`protected abstract void` `accept(GroovySourceAST currentNode)`
`protected void` `acceptChildren(GroovySourceAST t)`
`protected void` `acceptSiblings(GroovySourceAST t)`
`protected void` `closingVisit(GroovySourceAST t)`
`protected void` `openingVisit(GroovySourceAST t)`
`protected GroovySourceAST` `pop()`
`antlr.collections.AST` `process(antlr.collections.AST t)` performs some processing on the supplied AST node.
`protected void` `push(GroovySourceAST ast)`
`protected void` `secondVisit(GroovySourceAST t)`
`protected void` `setUp(GroovySourceAST ast)`
`protected void` `skip(GroovySourceAST expr)`
`protected void` `subsequentVisit(GroovySourceAST t)`
`protected void` `tearDown(GroovySourceAST ast)`
`protected void` `visitNode(GroovySourceAST ast, int n)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### unvisitedNodes

    protected java.util.List<GroovySourceAST> unvisitedNodes

### Constructor Detail

#### TraversalHelper

    public TraversalHelper(Visitor visitor)

### Method Detail

#### setUp

    protected void setUp(GroovySourceAST ast)

#### tearDown

    protected void tearDown(GroovySourceAST ast)

#### push

    protected void push(GroovySourceAST ast)

#### pop

    protected GroovySourceAST pop()

#### visitNode

    protected void visitNode(GroovySourceAST ast,
                             int n)

#### accept

    protected abstract void accept(GroovySourceAST currentNode)

#### accept_v_FirstChildsFirstChild_v_Child2_Child3_v_Child4_v___v_LastChild

    protected void accept_v_FirstChildsFirstChild_v_Child2_Child3_v_Child4_v___v_LastChild(GroovySourceAST t)

#### accept_v_FirstChildsFirstChild_v_RestOfTheChildren

    protected void accept_v_FirstChildsFirstChild_v_RestOfTheChildren(GroovySourceAST t)

#### accept_FirstChild_v_SecondChild

    protected void accept_FirstChild_v_SecondChild(GroovySourceAST t)

#### accept_FirstChild_v_SecondChild_v

    protected void accept_FirstChild_v_SecondChild_v(GroovySourceAST t)

#### accept_SecondChild_v_ThirdChild_v

    protected void accept_SecondChild_v_ThirdChild_v(GroovySourceAST t)

#### accept_FirstChild_v_SecondChildsChildren_v

    protected void accept_FirstChild_v_SecondChildsChildren_v(GroovySourceAST t)

#### accept_v_FirstChild_SecondChild_v_ThirdChild_v

    protected void accept_v_FirstChild_SecondChild_v_ThirdChild_v(GroovySourceAST t)

#### accept_FirstChild_v_SecondChild_v_ThirdChild_v

    protected void accept_FirstChild_v_SecondChild_v_ThirdChild_v(GroovySourceAST t)

#### accept_FirstSecondAndThirdChild_v_v_ForthChild

    protected void accept_FirstSecondAndThirdChild_v_v_ForthChild(GroovySourceAST t)

#### accept_v_FirstChild_2ndv_SecondChild_v___LastChild_v

    protected void accept_v_FirstChild_2ndv_SecondChild_v___LastChild_v(GroovySourceAST t)

#### accept_v_FirstChild_v_SecondChild_v___LastChild_v

    protected void accept_v_FirstChild_v_SecondChild_v___LastChild_v(GroovySourceAST t)

#### accept_v_FirstChild_v

    protected void accept_v_FirstChild_v(GroovySourceAST t)

#### accept_v_Siblings_v

    protected void accept_v_Siblings_v(GroovySourceAST t)

#### accept_v_AllChildren_v_Siblings

    protected void accept_v_AllChildren_v_Siblings(GroovySourceAST t)

#### accept_v_AllChildren_v

    protected void accept_v_AllChildren_v(GroovySourceAST t)

#### accept_FirstChild_v_RestOfTheChildren

    protected void accept_FirstChild_v_RestOfTheChildren(GroovySourceAST t)

#### accept_FirstChild_v_RestOfTheChildren_v_LastChild

    protected void accept_FirstChild_v_RestOfTheChildren_v_LastChild(GroovySourceAST t)

#### accept_FirstChild_v_RestOfTheChildren_v

    protected void accept_FirstChild_v_RestOfTheChildren_v(GroovySourceAST t)

#### accept_v_FirstChild_v_RestOfTheChildren

    protected void accept_v_FirstChild_v_RestOfTheChildren(GroovySourceAST t)

#### accept_v_FirstChild_v_RestOfTheChildren_v

    protected void accept_v_FirstChild_v_RestOfTheChildren_v(GroovySourceAST t)

#### acceptSiblings

    protected void acceptSiblings(GroovySourceAST t)

#### acceptChildren

    protected void acceptChildren(GroovySourceAST t)

#### skip

    protected void skip(GroovySourceAST expr)

#### openingVisit

    protected void openingVisit(GroovySourceAST t)

#### secondVisit

    protected void secondVisit(GroovySourceAST t)

#### subsequentVisit

    protected void subsequentVisit(GroovySourceAST t)

#### closingVisit

    protected void closingVisit(GroovySourceAST t)

#### process

    public antlr.collections.AST process(antlr.collections.AST t)

Description copied from interface: `AntlrASTProcessor`
performs some processing on the supplied AST node.

Specified by:
  `process` in interface `AntlrASTProcessor`
Parameters:
  `t` - the AST node to process.
Returns:
  possibly returns the AST modified or null, depends on the implementation.